



##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka.templates.ClassicLayout import ClassicLayout
from prewikka import siteconfig

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc7'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 7)
__CHEETAH_genTime__ = 1169098779.0719371
__CHEETAH_genTimestamp__ = 'Thu Jan 18 00:39:39 2007'
__CHEETAH_src__ = 'prewikka/templates/About.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Nov 18 06:30:32 2006'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class About(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        ClassicLayout.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
<div id="about" style="border: 0px solid red;"> 

<div style="vertical-align: top; padding-right: 40px;">

<h2 style="font-weight: bold; color: #4D535C;">Prewikka ''')
        _v = VFFSL(SL,"siteconfig.version",True) # '$siteconfig.version' on line 10, col 57
        if _v is not None: write(_filter(_v, rawExpr='$siteconfig.version')) # from line 10, col 57.
        write('''</h2>

<br />

<p style="font-size: 11px; font-weight: bold; font-style: italic; color: #4D535C;">
 <a href="http://www.prelude-ids.com">PreludeIDS Technologies</a> provides support to Large Accounts, Major Companies and Government Agencies around the world, to improve and strengthen the security of their systems and networks.
</p>

</div>

<br/>

<img style="margin-left: 10px; margin-top: -10px; padding: 0; float: right;" src="prewikka/images/prelude-logo.gif" alt="Prelude-IDS logo" />

<div style="display: block; vertical-align: middle;">

<br/>

<ul><li style="color: #6f9662; font-weight: bold;">Customizing Prelude
  <p>
  In keeping with the Open Source spirit, we encourage you to participate in the development of your application. You can order customized versions of Prelude to suit your needs: adapting, adding on functionality etc. Because they are carried out by PreludeIDS engineers, you know that any modifications made to the system will be integrated optimally and guaranteed by our technical support department. Additionally, the company can extend Prelude to handle yet unsupported sensors (including proprietary), ruleset extension to handle new devices and porting of Prelude to unsupported operating systems.
  </p>
</li>

<li style="color: #6f9662; font-weight: bold;">Software Maintenance and Technical Support
  <p>
   PreludeIDS maintenance and support services guarantee optimal operation of the Prelude platform on your infrastructure. With our support services, you benefit from priority assistance and the expertise of our engineers, while the maintenance service we offer maintains and updates your software.
  </p>
</li>

<li style="color: #6f9662; font-weight: bold;">Commercial licenses
  <p>
  The Prelude framework is licensed under the <a href="http://www.gnu.org/licenses/gpl.txt">General Public License</a>.
  PreludeIDS provides specific commercial licenses to allow proprietary systems based on Prelude to be developed and to interoperate.
   </p>
</li>

<li style="color: #6f9662; font-weight: bold;">Advice, Deployment and Training
  <p>
  Through our partners, you have access to an array of top-of-the-line security services. By advising you on how to secure your infrastructure, deploying Prelude and training your users, we provide a turnkey solution to secure your infrastructure, delivered by specialists.
  </p>
</li>

</ul>

</div>

<br/>

<div style="display: table-row; vertical-align: bottom;width: 100%;"> 

<table align="center" id="about_contact">
 <tr style="text-align: center;">
  <td><b>Contact</b></td>
  <td><b>Headquarter</b></td>
  <td><b>Website</b></td>
 </tr>
 <tr>
  <td><a href="mailto:info@prelude-ids.com">info@prelude-ids.com</a></td>
  <td>2, rue David Girin</td>
  <td><a href="http://www.prelude-ids.com">http://www.prelude-ids.com</a></td>
 </tr>
 <tr>
  <td><b>Phone:</b> +33 8 70 70 21 58</td>
  <td>69002 Lyon</td>
  <td>&nbsp;</td>
 </tr>
 <tr>
  <td>&nbsp;&nbsp;&nbsp;<b>Fax:</b> +33 4 78 42 21 58</td>
  <td>France</td>
  <td>&nbsp;</td>
 </tr>
</table>

</div>
<center style="vertical-align: bottom;" >Copyright &copy; 2004 - 2006 PreludeIDS Technologies. All right reserved.</center>

</div>

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('\n')
        self.main_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_About= 'writeBody'

## END CLASS DEFINITION

if not hasattr(About, '_initCheetahAttributes'):
    templateAPIClass = getattr(About, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(About)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=About()).run()


