



##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka import User
from prewikka.templates.ClassicLayout import ClassicLayout

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc7'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 7)
__CHEETAH_genTime__ = 1169098780.6569459
__CHEETAH_genTimestamp__ = 'Thu Jan 18 00:39:40 2007'
__CHEETAH_src__ = 'prewikka/templates/MessageListing.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Nov 18 06:30:32 2006'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class MessageListing(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        ClassicLayout.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def layout_start_hook(self, **KWS):



        ## CHEETAH: generated from #def layout_start_hook at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('<form method="post" action="?">\n')
        for name, value in VFFSL(SL,"hidden_parameters",True): # generated from line 6, col 1
            write('  <input type="hidden" name="')
            _v = VFFSL(SL,"name",True) # '$name' on line 7, col 30
            if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 7, col 30.
            write('" value="')
            _v = VFFSL(SL,"value",True) # '$value' on line 7, col 44
            if _v is not None: write(_filter(_v, rawExpr='$value')) # from line 7, col 44.
            write('"/>\n')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def layout_end_hook(self, **KWS):



        ## CHEETAH: generated from #def layout_end_hook at line 11, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('</form>\n')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def message_listing_header(self, **KWS):



        ## CHEETAH: generated from #def message_listing_header at line 18, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 17, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _v = VFFSL(SL,"message_listing_header",True) # '$message_listing_header' on line 20, col 1
        if _v is not None: write(_filter(_v, rawExpr='$message_listing_header')) # from line 20, col 1.
        write('''

<table id="message_list_result">
  ''')
        _v = VFFSL(SL,"message_fields_header",True) # '$message_fields_header' on line 23, col 3
        if _v is not None: write(_filter(_v, rawExpr='$message_fields_header')) # from line 23, col 3.
        write('\n  <tbody>\n')
        row_classes = ("table_row_even", "table_row_odd")
        cnt = 0
        write('\n')
        for message in VFFSL(SL,"messages",True): # generated from line 28, col 5
            self._CHEETAH__globalSetVars["message"] = VFFSL(SL,"message",True)
            write('        <tr class="')
            _v = VFFSL(SL,"row_classes",True)[VFFSL(SL,"cnt",True) % 2] # '$row_classes[$cnt % 2]' on line 30, col 20
            if _v is not None: write(_filter(_v, rawExpr='$row_classes[$cnt % 2]')) # from line 30, col 20.
            write('">\n          ')
            _v = VFFSL(SL,"message_fields",True) # '$message_fields' on line 31, col 11
            if _v is not None: write(_filter(_v, rawExpr='$message_fields')) # from line 31, col 11.
            write('\n          <td class="static_content_column">\n')
            if VFN(VFFSL(SL,"prewikka.user",True),"has",False)(User.PERM_IDMEF_ALTER): # generated from line 33, col 13
                write('              <input class="checkbox" type="checkbox" name="delete" value="')
                _v = VFFSL(SL,"message.delete",True) # '$message.delete' on line 34, col 76
                if _v is not None: write(_filter(_v, rawExpr='$message.delete')) # from line 34, col 76.
                write('"/>\n')
            else: # generated from line 35, col 6
                write('\t      &nbsp;\n')
            write('          </td>\n        </tr>\n')
            cnt += 1
        write('\n')
        if VFN(VFFSL(SL,"prewikka.user",True),"has",False)(User.PERM_IDMEF_ALTER) and VFFSL(SL,"cnt",True): # generated from line 43, col 1
            write('''     <tr>
      <td colspan="4">&nbsp;</td>
      <td style="text-align: right;"><input type="submit" value="Delete"/></td>
      <td class="static_content_column">
       <input class="checkbox" type="checkbox" id="allbox" onclick="checkBoxByName('delete', document.forms[0].allbox.checked);"/>
      </td>
     </tr>
    </tbody>
''')
        write('\n  </table>\n')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def timeline_extra_content(self, **KWS):



        ## CHEETAH: generated from #def timeline_extra_content at line 62, col 3.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def menu_extra_content(self, **KWS):



        ## CHEETAH: generated from #block menu_extra_content at line 60, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('<table id="timeline">\n  ')
        _v = VFFSL(SL,"timeline_extra_content",True) # '$timeline_extra_content' on line 64, col 3
        if _v is not None: write(_filter(_v, rawExpr='$timeline_extra_content')) # from line 64, col 3.
        write('''
  
  <tr>
   <td id="timeline_step_label">Step:</td>
   <td id="timeline_step_value">
    <input name="timeline_value" type="text" size="2" value="''')
        _v = VFFSL(SL,"timeline.value",True) # '$timeline.value' on line 69, col 62
        if _v is not None: write(_filter(_v, rawExpr='$timeline.value')) # from line 69, col 62.
        write('''"/>
   </td>

   <td colspan=2 id="timeline_unit">
    <select class="timeline_unit_select" name="timeline_unit">
     <option value="min" ''')
        _v = VFFSL(SL,"timeline.min_selected",True) # '$timeline.min_selected' on line 74, col 26
        if _v is not None: write(_filter(_v, rawExpr='$timeline.min_selected')) # from line 74, col 26.
        write('>Minutes</option>\n     <option value="hour" ')
        _v = VFFSL(SL,"timeline.hour_selected",True) # '$timeline.hour_selected' on line 75, col 27
        if _v is not None: write(_filter(_v, rawExpr='$timeline.hour_selected')) # from line 75, col 27.
        write('>Hours</option>\n     <option value="day" ')
        _v = VFFSL(SL,"timeline.day_selected",True) # '$timeline.day_selected' on line 76, col 26
        if _v is not None: write(_filter(_v, rawExpr='$timeline.day_selected')) # from line 76, col 26.
        write('>Days</option>\n     <option value="month" ')
        _v = VFFSL(SL,"timeline.month_selected",True) # '$timeline.month_selected' on line 77, col 28
        if _v is not None: write(_filter(_v, rawExpr='$timeline.month_selected')) # from line 77, col 28.
        write('>Months</option>\n     <option value="year" ')
        _v = VFFSL(SL,"timeline.year_selected",True) # '$timeline.year_selected' on line 78, col 27
        if _v is not None: write(_filter(_v, rawExpr='$timeline.year_selected')) # from line 78, col 27.
        write('>Years</option>\n     <option value="unlimited" ')
        _v = VFFSL(SL,"timeline.unlimited_selected",True) # '$timeline.unlimited_selected' on line 79, col 32
        if _v is not None: write(_filter(_v, rawExpr='$timeline.unlimited_selected')) # from line 79, col 32.
        write('''>Unlimited</option>
    </select>
   </td>
  </tr>

  <tr>
    <td id="timezone_control_label">Tz:</td>
    <td colspan="3">
      <select class="timezone_control_select" name="timezone">
        <option value="frontend_localtime" ''')
        _v = VFFSL(SL,"timeline.frontend_localtime_selected",True) # '$timeline.frontend_localtime_selected' on line 88, col 44
        if _v is not None: write(_filter(_v, rawExpr='$timeline.frontend_localtime_selected')) # from line 88, col 44.
        write('>Frontend localtime</option>\n\t<option value="sensor_localtime" ')
        _v = VFFSL(SL,"timeline.sensor_localtime_selected",True) # '$timeline.sensor_localtime_selected' on line 89, col 35
        if _v is not None: write(_filter(_v, rawExpr='$timeline.sensor_localtime_selected')) # from line 89, col 35.
        write('>Sensor localtime</option>\n\t<option value="utc" ')
        _v = VFFSL(SL,"timeline.utc_selected",True) # '$timeline.utc_selected' on line 90, col 22
        if _v is not None: write(_filter(_v, rawExpr='$timeline.utc_selected')) # from line 90, col 22.
        write('''>UTC</option>
       </select>
     </td>
  </tr>
	
  <tr>
   <td id="timeline_limit_label">Limit:</td>

   <td>
    <input style="display: inline;" id="timeline_limit_value" type="text" size="2" name="limit" value="''')
        _v = VFFSL(SL,"limit",True) # '$limit' on line 99, col 104
        if _v is not None: write(_filter(_v, rawExpr='$limit')) # from line 99, col 104.
        write('''"/>
   </td>

   <td id="timeline_submit">
 	<input style="display:inline;" type="submit" name="apply" value="Apply" />
   </td>

   <td id="timeline_submit">
      <input style="display:inline;" type="submit" name="_save" value="Save" />
   </td>
  </tr>

''')
        if not VFFSL(SL,"timeline.start",True): # generated from line 111, col 1
            write(' <tr><td colspan="4" class="timeline_range">Unlimited</td></tr>\n <tr><td colspan="4" class="timeline_range">-</td></tr>\n')
        else: # generated from line 114, col 1
            write(' <tr><td colspan="4" class="timeline_range">')
            _v = VFFSL(SL,"timeline.start",True) # '$timeline.start' on line 115, col 45
            if _v is not None: write(_filter(_v, rawExpr='$timeline.start')) # from line 115, col 45.
            write('</td></tr>\n <tr><td colspan="4" class="timeline_range">')
            _v = VFFSL(SL,"timeline.end",True) # '$timeline.end' on line 116, col 45
            if _v is not None: write(_filter(_v, rawExpr='$timeline.end')) # from line 116, col 45.
            write('</td></tr>\n')
        write(' <tr><td colspan="4" class="timeline_range">')
        _v = VFFSL(SL,"timeline.range_timezone",True) # '$timeline.range_timezone' on line 118, col 45
        if _v is not None: write(_filter(_v, rawExpr='$timeline.range_timezone')) # from line 118, col 45.
        write('''</td></tr>

 <tr>
  <td colspan="4" style="text-align: center;">
   <table><tr>
''')
        if VFFSL(SL,"timeline.prev",True): # generated from line 123, col 5
            write('     <td class="timeline_control_prev"><a href="')
            _v = VFFSL(SL,"timeline.prev",True) # '$timeline.prev' on line 124, col 49
            if _v is not None: write(_filter(_v, rawExpr='$timeline.prev')) # from line 124, col 49.
            write('"><b>prev</b></a></td>\n')
        else: # generated from line 125, col 5
            write('     <td class="timeline_control_inactive"><b>prev</b></td>\n')
        write('\n')
        if VFFSL(SL,"timeline.current",True): # generated from line 129, col 5
            write('     <td class="timeline_control_cur"><a href="')
            _v = VFFSL(SL,"timeline.current",True) # '$timeline.current' on line 130, col 48
            if _v is not None: write(_filter(_v, rawExpr='$timeline.current')) # from line 130, col 48.
            write('"><b>current</b></a></td>\n')
        else: # generated from line 131, col 5
            write('     <td class="timeline_control_cur_inactive"><b>current</b></td>\n')
        write('\n')
        if VFFSL(SL,"timeline.next",True): # generated from line 135, col 5
            write('     <td class="timeline_control_next"><a href="')
            _v = VFFSL(SL,"timeline.next",True) # '$timeline.next' on line 136, col 49
            if _v is not None: write(_filter(_v, rawExpr='$timeline.next')) # from line 136, col 49.
            write('"><b>next</b></a></td>\n')
        else : # generated from line 137, col 5
            write('     <td class="timeline_control_inactive"><b>next</b></td>\n')
        write('''
   </tr></table>
  </td>
 </tr>

 </table>


<table id="message_list_nav">
  <tr>
''')
        if VFFSL(SL,"nav.prev",True): # generated from line 150, col 5
            write('      <td class="message_list_nav_button"><a href="')
            _v = VFFSL(SL,"nav.first",True) # '$nav.first' on line 151, col 52
            if _v is not None: write(_filter(_v, rawExpr='$nav.first')) # from line 151, col 52.
            write('">&lt;&lt;</a></td>\n      <td class="message_list_nav_button"><a href="')
            _v = VFFSL(SL,"nav.prev",True) # '$nav.prev' on line 152, col 52
            if _v is not None: write(_filter(_v, rawExpr='$nav.prev')) # from line 152, col 52.
            write('">&lt;</a></td>\n')
        else: # generated from line 153, col 5
            write('      <td class="message_list_nav_button_empty">&lt;&lt;</td>\n      <td class="message_list_nav_button_empty">&lt;</td>\n')
        if VFFSL(SL,"nav.next",True): # generated from line 157, col 5
            write('      <td class="message_list_nav_button"><a href="')
            _v = VFFSL(SL,"nav.next",True) # '$nav.next' on line 158, col 52
            if _v is not None: write(_filter(_v, rawExpr='$nav.next')) # from line 158, col 52.
            write('">&gt;</a></td>\n      <td class="message_list_nav_button"><a href="')
            _v = VFFSL(SL,"nav.last",True) # '$nav.last' on line 159, col 52
            if _v is not None: write(_filter(_v, rawExpr='$nav.last')) # from line 159, col 52.
            write('">&gt;&gt;</a></td>\n')
        else: # generated from line 160, col 5
            write('      <td class="message_list_nav_button_empty">&gt;</td>\n      <td class="message_list_nav_button_empty">&gt;&gt;</td>\n')
        write('''  </tr>
  <tr>
    <td class="message_list_nav_infos" colspan="4">
      ''')
        _v = VFFSL(SL,"nav.from",True) # '$nav.from' on line 167, col 7
        if _v is not None: write(_filter(_v, rawExpr='$nav.from')) # from line 167, col 7.
        write(' ... ')
        _v = VFFSL(SL,"nav.to",True) # '$nav.to' on line 167, col 21
        if _v is not None: write(_filter(_v, rawExpr='$nav.to')) # from line 167, col 21.
        write(' (total:')
        _v = VFFSL(SL,"total",True) # '$total' on line 167, col 36
        if _v is not None: write(_filter(_v, rawExpr='$total')) # from line 167, col 36.
        write(''')
    </td>
  </tr>
</table>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''




''')
        self.main_content(trans=trans)
        write('''



''')
        self.menu_extra_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_MessageListing= 'writeBody'

## END CLASS DEFINITION

if not hasattr(MessageListing, '_initCheetahAttributes'):
    templateAPIClass = getattr(MessageListing, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(MessageListing)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=MessageListing()).run()


