



##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka.templates.ClassicLayout import ClassicLayout

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc7'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 7)
__CHEETAH_genTime__ = 1169098779.940454
__CHEETAH_genTimestamp__ = 'Thu Jan 18 00:39:39 2007'
__CHEETAH_src__ = 'prewikka/templates/SensorListing.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Nov 18 06:30:32 2006'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class SensorListing(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        ClassicLayout.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 3, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('\n')
        if len(VFFSL(SL,"analyzers",True)) > 0: # generated from line 5, col 1
            write('  <form action="?" method="post">\n  <input type="hidden" name="view" value="sensor_messages_delete" />\n')
        write('''<table>
  <thead>
    <tr>
      <td>Name</td>
      <td>Type</td>
      <td>OS</td>
      <td>Node Name</td>
      <td>Node Location</td>
      <td>Node Address</td>
      <td>Last Heartbeat Time</td>
      <td>Latest status</td>
    </tr>
  </thead>
  <tbody>
''')
        if len(VFFSL(SL,"analyzers",True)) > 0: # generated from line 23, col 3
            row_classes = ("table_row_even", "table_row_odd")
            cnt = 0
            for analyzer in VFFSL(SL,"analyzers",True): # generated from line 26, col 5
                row_class = VFFSL(SL,"row_classes",True)[VFFSL(SL,"cnt",True)%2]
                write('      <tr class="')
                _v = VFFSL(SL,"row_class",True) # '$row_class' on line 28, col 18
                if _v is not None: write(_filter(_v, rawExpr='$row_class')) # from line 28, col 18.
                write('">\n        <td>\n\t  <a href="#" onclick="javascript:toggleVisibilityUnique(\'menu_')
                _v = VFFSL(SL,"cnt",True) # '$cnt' on line 30, col 65
                if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 30, col 65.
                write('\'); return false;">')
                _v = VFFSL(SL,"analyzer.name",True) # '$analyzer.name' on line 30, col 88
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.name')) # from line 30, col 88.
                write('</a>\n\t  <span id="menu_')
                _v = VFFSL(SL,"cnt",True) # '$cnt' on line 31, col 19
                if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 31, col 19.
                write('" class="popup_menu">\n            - <a href="')
                _v = VFFSL(SL,"analyzer.alert_listing",True) # '$analyzer.alert_listing' on line 32, col 24
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.alert_listing')) # from line 32, col 24.
                write('">Alert listing</a><br />\n            - <a href="')
                _v = VFFSL(SL,"analyzer.heartbeat_listing",True) # '$analyzer.heartbeat_listing' on line 33, col 24
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.heartbeat_listing')) # from line 33, col 24.
                write('">Heartbeat listing</a><br />\n            - <a href="')
                _v = VFFSL(SL,"analyzer.heartbeat_analyze",True) # '$analyzer.heartbeat_analyze' on line 34, col 24
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.heartbeat_analyze')) # from line 34, col 24.
                write('''">Heartbeat analysis</a><br />
          </span>
        </td>
        <td>''')
                _v = VFFSL(SL,"analyzer.model",True) # '$analyzer.model' on line 37, col 13
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.model')) # from line 37, col 13.
                write(' ')
                _v = VFFSL(SL,"analyzer.version",True) # '$analyzer.version' on line 37, col 29
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.version')) # from line 37, col 29.
                write('</td>\n        <td>')
                _v = VFFSL(SL,"analyzer.ostype",True) # '$analyzer.ostype' on line 38, col 13
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.ostype')) # from line 38, col 13.
                write(' ')
                _v = VFFSL(SL,"analyzer.osversion",True) # '$analyzer.osversion' on line 38, col 30
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.osversion')) # from line 38, col 30.
                write('</td>\n        <td>')
                _v = VFFSL(SL,"analyzer.node_name",True) # '$analyzer.node_name' on line 39, col 13
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.node_name')) # from line 39, col 13.
                write('</td>\n        <td>')
                _v = VFFSL(SL,"analyzer.node_location",True) # '$analyzer.node_location' on line 40, col 13
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.node_location')) # from line 40, col 13.
                write('</td>\n        <td>\n')
                if len(VFFSL(SL,"analyzer.node_addresses",True)) > 0: # generated from line 42, col 9
                    for address in VFFSL(SL,"analyzer.node_addresses",True): # generated from line 43, col 11
                        cnt += 1
                        write('\n\t   <a href="#" onclick="javascript:toggleVisibilityUnique(\'menu_')
                        _v = VFFSL(SL,"cnt",True) # '$cnt' on line 46, col 66
                        if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 46, col 66.
                        write('\'); return false;">')
                        _v = VFFSL(SL,"address.value",True) # '$address.value' on line 46, col 89
                        if _v is not None: write(_filter(_v, rawExpr='$address.value')) # from line 46, col 89.
                        write('</a><br />\n           <span id="menu_')
                        _v = VFFSL(SL,"cnt",True) # '$cnt' on line 47, col 27
                        if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 47, col 27.
                        write('" class="popup_menu">\n\n            - <a href="')
                        _v = VFFSL(SL,"address.inline_filter",True) # '$address.inline_filter' on line 49, col 24
                        if _v is not None: write(_filter(_v, rawExpr='$address.inline_filter')) # from line 49, col 24.
                        write('">Filter on address</a><br />\n            - <a target="')
                        _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 50, col 26
                        if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 50, col 26.
                        write('" href="https://www.prelude-ids.com/host_details.php?host=')
                        _v = VFFSL(SL,"address.value",True) # '$address.value' on line 50, col 114
                        if _v is not None: write(_filter(_v, rawExpr='$address.value')) # from line 50, col 114.
                        write('">Address information</a><br />\n     \n')
                        for name, link in VFFSL(SL,"address.host_commands",True): # generated from line 52, col 6
                            write('            - <a href="')
                            _v = VFFSL(SL,"link",True) # '$link' on line 53, col 24
                            if _v is not None: write(_filter(_v, rawExpr='$link')) # from line 53, col 24.
                            write('">')
                            _v = VFFSL(SL,"name",True) # '$name' on line 53, col 31
                            if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 53, col 31.
                            write('</a><br />\n')
                        write('           </span>\n\n')
                else: # generated from line 58, col 9
                    write('          n/a\n')
                write('        </td>\n        <td>')
                _v = VFFSL(SL,"analyzer.last_heartbeat_time",True) # '$analyzer.last_heartbeat_time' on line 62, col 13
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.last_heartbeat_time')) # from line 62, col 13.
                write('</td>\n        <td class="heartbeat_analyze_sensor_status_')
                _v = VFFSL(SL,"analyzer.status",True) # '$analyzer.status' on line 63, col 52
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.status')) # from line 63, col 52.
                write('"><b>')
                _v = VFFSL(SL,"analyzer.status_meaning",True) # '$analyzer.status_meaning' on line 63, col 73
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.status_meaning')) # from line 63, col 73.
                write('</b></td>\n        <td><input class="checkbox" type="checkbox" name="analyzerid" value="')
                _v = VFFSL(SL,"analyzer.analyzerid",True) # '$analyzer.analyzerid' on line 64, col 78
                if _v is not None: write(_filter(_v, rawExpr='$analyzer.analyzerid')) # from line 64, col 78.
                write('" /></td>\n      </tr>\n')
                cnt += 1
        else: # generated from line 68, col 3
            write('    <tr><td class="not_available" style="text-align: center;" colspan="9">No agent available</td></tr>\n')
        write('''  </tbody>
</table>

<br/>

''')
        if len(VFFSL(SL,"analyzers",True)) > 0: # generated from line 76, col 1
            write('''  <div style="text-align: right; vertical-align: bottom;">
    <input class="checkbox" type="checkbox" name="alerts" /><b>Alerts</b>
    <input class="checkbox" type="checkbox" name="heartbeats" /><b>Heartbeats</b>
    &nbsp;<input type="submit" value="Delete" />
  </div>
''')
        write('\n</form>\n')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('\n')
        self.main_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_SensorListing= 'writeBody'

## END CLASS DEFINITION

if not hasattr(SensorListing, '_initCheetahAttributes'):
    templateAPIClass = getattr(SensorListing, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(SensorListing)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=SensorListing()).run()


